package eu.eudat.dao.entities;

import java.util.List;
import java.util.UUID;

import eu.eudat.dao.Dao;
import eu.eudat.entities.Dataset;
import eu.eudat.entities.Project;
import eu.eudat.entities.responses.IDLabelPair;
import eu.eudat.models.dataset.DatasetTableRequest;
import eu.eudat.models.project.ProjectTableRequest;
import org.springframework.stereotype.Service;

public interface DatasetDao extends Dao<Dataset, UUID> {


	public List<UUID> listAllIDs();

	List<IDLabelPair> listAllIDsLabels();

	List<Dataset> getDatasetsOfDmp(UUID dmpID);

	public List<Dataset> getWithCriteria(DatasetTableRequest datasetTableRequest);

}