package eu.eudat.managers;

import eu.eudat.dao.entities.DatasetDao;
import eu.eudat.dao.entities.ProjectDao;
import eu.eudat.models.dataset.Dataset;
import eu.eudat.models.dataset.DatasetTableRequest;
import eu.eudat.models.helpers.DataTableData;
import eu.eudat.models.project.Project;
import eu.eudat.models.project.ProjectTableRequest;
import eu.eudat.utilities.builders.DomainModelConverter;

import java.util.List;
import java.util.UUID;

/**
 * Created by ikalyvas on 12/15/2017.
 */
public class DatasetManager {

    public DataTableData<Dataset> getPaged(DatasetDao datatasetRepository, DatasetTableRequest datasetTableRequest) throws IllegalAccessException, InstantiationException{
        List<Dataset> datasets = new DomainModelConverter<eu.eudat.entities.Dataset, Dataset>().fromDataModel( datatasetRepository.getWithCriteria(datasetTableRequest), eu.eudat.models.dataset.Dataset.class);
        DataTableData<eu.eudat.models.dataset.Dataset> dataTable = new DataTableData<eu.eudat.models.dataset.Dataset>();
        dataTable.setData(datasets);
        dataTable.setTotalCount(datatasetRepository.count());
        return dataTable;
    }

    public eu.eudat.models.dataset.Dataset getSingle(DatasetDao datatasetRepository, String id) throws InstantiationException, IllegalAccessException{
        eu.eudat.models.dataset.Dataset dataset = new eu.eudat.models.dataset.Dataset();
        dataset.fromDataModel(datatasetRepository.read(UUID.fromString(id)));
        return dataset;
    }
}
