package eu.eudat.models.admin.components.datasetprofile;

import eu.eudat.entities.xmlmodels.modeldefinition.*;
import eu.eudat.utilities.ModelDefinition;
import org.apache.commons.lang3.RandomStringUtils;

import eu.eudat.models.components.commons.DefaultValue;
import eu.eudat.models.components.commons.Multiplicity;
import eu.eudat.models.components.commons.ViewStyle;
import eu.eudat.models.components.commons.Visibility;
import eu.eudat.utilities.ViewStyleDefinition;
import eu.eudat.utilities.builders.ModelBuilder;

public class Field implements ViewStyleDefinition<eu.eudat.entities.xmlmodels.viewstyledefinition.Field>,ModelDefinition<eu.eudat.entities.xmlmodels.modeldefinition.Field>,Comparable{
	private String id;
	private Integer ordinal;
	private String title;
	private String value;
	private String description;
	private String extendedDescription;
	private ViewStyle viewStyle;
	private String datatype;
	private boolean defaultVisibility;
	private int page;
	private DefaultValue defaultValue;
	private Multiplicity multiplicity;
	private Object data;
	private Visibility visible;	
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	
	public int getOrdinal(){
		return ordinal;
	}
	
	public void setOrdinal(int ordinal){
		this.ordinal = ordinal;
	}
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public String getValue() {
		return value;
	}
	public void setValue(String value) {
		this.value = value;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public String getExtendedDescription() {
		return extendedDescription;
	}
	public void setExtendedDescription(String extendedDescription) {
		this.extendedDescription = extendedDescription;
	}
	public ViewStyle getViewStyle() {
		return viewStyle;
	}
	public void setViewStyle(ViewStyle viewStyle) {
		this.viewStyle = viewStyle;
	}
	public boolean getDefaultVisibility() {
		return defaultVisibility;
	}
	public void setDefaultVisibility(boolean defaultVisibility) {
		this.defaultVisibility = defaultVisibility;
	}
	public int getPage() {
		return page;
	}
	public void setPage(int page) {
		this.page = page;
	}		
		
	public DefaultValue getDefaultValue() {
		return defaultValue;
	}
	public void setDefaultValue(DefaultValue defaultValue) {
		this.defaultValue = defaultValue;
	}
	public String getDatatype() {
		return datatype;
	}
	public void setDatatype(String datatype) {
		this.datatype = datatype;
	}
	
	public Multiplicity getMultiplicity() {
		return multiplicity;
	}
	public void setMultiplicity(Multiplicity multiplicity) {
		this.multiplicity = multiplicity;
	}		
	
	public Object getData() {
		return data;
	}
	public void setData(Object data) {
		this.data = data;
	}
	
	
	public Visibility getVisible() {
		return visible;
	}
	public void setVisible(Visibility visible) {
		this.visible = visible;
	}
	@Override
	public eu.eudat.entities.xmlmodels.modeldefinition.Field toDatabaseDefinition(eu.eudat.entities.xmlmodels.modeldefinition.Field field) {
		if(this.id == null||this.id.isEmpty())this.id = "field_"+RandomStringUtils.random(5, true, true);

		field.setDatatype(this.datatype);
		field.setDefaultValue(this.defaultValue);
		field.setId(this.id);
		field.setMultiplicity(this.multiplicity);
		field.setOrdinal(this.ordinal);
		return field;
	}
	@Override
	public void fromDatabaseDefinition(eu.eudat.entities.xmlmodels.modeldefinition.Field item) {
		this.datatype = item.getDatatype();
		this.defaultValue = item.getDefaultValue();
		this.multiplicity = item.getMultiplicity();
	}
	@Override
	public eu.eudat.entities.xmlmodels.viewstyledefinition.Field toDatabaseDefinition(eu.eudat.entities.xmlmodels.viewstyledefinition.Field field) {
		if(this.id == null||this.id.isEmpty())this.id = "field_"+RandomStringUtils.random(5, true, true);

		field.setDefaultVisibility(this.defaultVisibility);
		field.setDescription(this.description);
		field.setExtendedDescription(this.extendedDescription);
		field.setId(this.id);
		field.setOrdinal(this.ordinal);
		field.setTitle(this.title);
		field.setViewStyle(this.viewStyle);
		field.setData(new ModelBuilder().toFieldData(data, this.viewStyle.getRenderStyle()));
		field.setVisible(this.visible);
		return field;
	}
	@Override
	public void fromDatabaseDefinition(eu.eudat.entities.xmlmodels.viewstyledefinition.Field item) {
		this.defaultVisibility = item.getDefaultVisibility();
		this.description = item.getDescription();
		this.extendedDescription = item.getExtendedDescription();
		this.id = item.getId();
		this.ordinal = item.getOrdinal();
		this.title = item.getTitle();
		this.viewStyle = item.getViewStyle();
		this.data = item.getData();
		this.visible = item.getVisible();
	}
	@Override
	public int compareTo(Object o) {
		return this.ordinal.compareTo(((Field)o).ordinal);
	}			
	
	
}
