import { FormGenerator } from "../../../utilities/forms/FormGenerator";
import { ValidationContext } from "../../../utilities/validators/ValidationContext";
import { FormBuilder, FormGroup } from "@angular/forms";

export class AutoCompleteItem implements FormGenerator {

    public value: string;
    public text: string;
    public description: string;
    constructor(value: string, text: string, description: string) {
        this.value = value;
        this.text = text;
        this.description = description;
    }

    buildForm(context: ValidationContext, disabled: boolean = false): FormGroup {
        return new FormBuilder().group({
            value: [{ value: this.value, disabled: disabled }, context.getValidation('value').validators],
            text: [{ value: this.text, disabled: disabled }, context.getValidation('text').validators],
            description: [{ value: this.description, disabled: disabled }, context.getValidation('description').validators]
        });
    }
}
